#version 430                                                                        
                                                                                    
layout (location = 0) in vec3 Position;                                             
layout (location = 1) in vec2 TexCoord;                                             
layout (location = 2) in vec3 Normal;                                               
layout (location = 3) in ivec4 BoneIDs;
layout (location = 4) in vec4 Weights;

out VertexData {
    vec3 position_world;
    vec3 normal_world;
    vec2 uv;
} vert;                                                             

const int MAX_BONES = 100;

uniform mat4 gWVP;
uniform mat4 gWorld;
uniform mat3 normx;
uniform mat4 gBones[MAX_BONES];

void main()
{       
    //mat4 BoneTransform = gBones[BoneIDs[0]] * Weights[0];
    //BoneTransform     += gBones[BoneIDs[1]] * Weights[1];
    //BoneTransform     += gBones[BoneIDs[2]] * Weights[2];
    //BoneTransform     += gBones[BoneIDs[3]] * Weights[3];

    //vec4 PosL    = BoneTransform * vec4(Position, 1.0);
    //gl_Position  = gWVP * PosL;
    //vert.uv    = TexCoord;
    //vec4 NormalL = BoneTransform * vec4(Normal, 0.0);
    
    //vert.normal_world      = (gWorld * NormalL).xyz;
    //vert.position_world    = (gWorld * PosL).xyz; 



    vert.normal_world = normx * Normal;
    vert.uv = TexCoord;
    vec4 position_world_ = gWorld * vec4(Position, 1);
    vert.position_world = position_world_.xyz;
    gl_Position = gWVP * position_world_;
}
